VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsOrders"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' These property values will be displayed on frmDemo
Public OrderDate As Variant
Public OrderID As Long

' We will get above property values from rsOrders
Private rsOrders As ADODB.Recordset

' The value of OrderID will determine OrderDetails Records
Public WithEvents OrderDetails As clsOrderDetails
Attribute OrderDetails.VB_VarHelpID = -1

' The value of mCustomerID will determine Order Records
Private mCustomerID As String

' Events to notify frmDemo that values have changed and therefore update display
Public Event OrderInfoChg()
Public Event DetailsChg()


Public Property Let CustomerID(ByVal strData As String)

mCustomerID = strData

' set our connection
Dim cn As ADODB.Connection
Set cn = New ADODB.Connection
cn.CursorLocation = adUseClient
cn.Open "PROVIDER=Microsoft.Jet.OLEDB.4.0;Data Source=" & _
    DB_PATH & ";"

' get our recordset
Set rsOrders = New ADODB.Recordset
Dim sql As String
sql = "SELECT OrderDate, OrderID From Orders " & _
    "WHERE CustomerID = '" & mCustomerID & "' " & _
    "ORDER BY OrderDate DESC;"
rsOrders.Open sql, cn, adOpenStatic, adLockOptimistic
If rsOrders.EOF Then
    UpdateValues True
Else
    Call UpdateValues       ' update our properties to be displayed on frmDemo
End If
End Property

Public Sub MoveFirst()
' prevent error if no orders for this customer
If rsOrders.RecordCount = 0 Then Exit Sub
rsOrders.MoveFirst
Call UpdateValues
End Sub

Public Sub MoveLast()
' prevent error if no orders for this customer
If rsOrders.RecordCount = 0 Then Exit Sub
rsOrders.MoveLast
Call UpdateValues
End Sub

Public Sub MovePrevious()
' prevent error if no orders for this customer
If rsOrders.RecordCount = 0 Then Exit Sub
With rsOrders
    .MovePrevious
    If .BOF Then .MoveFirst     ' prevent going off beginning of recordset
End With
Call UpdateValues
End Sub

Public Sub MoveNext()
' prevent error if no orders for this customer
If rsOrders.RecordCount = 0 Then Exit Sub
With rsOrders
    .MoveNext
    If .EOF Then .MoveLast      ' prevent going off end of recordset
End With
Call UpdateValues
End Sub

Private Sub UpdateValues(Optional ByVal NoOrders As Boolean)
' update our properties to be displayed on frmDemo
If NoOrders Then
    OrderDate = ""
    OrderID = 0
Else
    With rsOrders
        OrderDate = !OrderDate
        OrderID = !OrderID
    End With
End If
' provide an entirely new recordset for our frmDemo.DataGrid1
Set OrderDetails = New clsOrderDetails
OrderDetails.OrderID = OrderID
' tell frmDemo values have changed
RaiseEvent OrderInfoChg

End Sub

Private Sub OrderDetails_DetailsInfoChg()
' pass on to frmDemo
RaiseEvent DetailsChg
End Sub

Private Sub Class_Terminate()
' close recordset
rsOrders.Close
End Sub
